-----------Listing du programme t1_agoraserverada3.adb slice-------------

procedure t1_agoraserverada3 is 



   Nb_Process : constant        :=3;
   type Id is range 1 .. Nb_Process;







  protected type T_Agora is 
    entry Rendezvous(X: in Id;        X_Other: out Id;               Group_Leader: out Id);
  private 
    entry Resume(X: in Id;        X_Other: out Id;               Group_Leader: out Id);
    First_Call : Boolean := True;
    First_Partner : Id;
    Second_Partner : Id;
  end;


    task type T_Process is 
        entry Get_Id(Y : in Id);
        entry Start_Peering              ;
        entry Finish_Peering                ;
     end;




    protected type T_Register is 
       procedure Update;
  private 

  end;

   protected body T_Register is 
    procedure Update is begin                    null;end;
  end;

  System_Count : T_Register;

   type Process_Array is array (Id) of T_Process;

   Process : Process_Array;

   Agora : T_Agora;





   protected body T_Agora is 

    entry Rendezvous(X: in Id;        X_Other: out Id;               Group_Leader: out Id) when                     True is 
      begin 
        if First_Call then 
          First_Partner := X;
          First_Call := False;
          requeue Resume;
        else 
          Second_Partner := X;                   X_Other := First_Partner;                        Group_Leader := First_Partner;
          First_Call := True;
        end if;
    end;

    entry Resume(X: in Id;        X_Other: out Id;               Group_Leader: out Id) when                     First_Call is 
      begin 
        X_Other := Second_Partner;
        Group_Leader := X;
      end;
  end;


   task body T_Process is 
      Ego     : Id;
      Partner : Id;
      Leader  : Id;

   begin 
      accept Get_Id(Y : in Id) do 
         Ego := Y;
      end;

      loop 

         Agora.Rendezvous(Ego,   Partner,       Leader);






         if Ego = Leader then 

            Process(Partner).Start_Peering                       ;


            Process(Partner).Finish_Peering                       ;
         else 
            accept Start_Peering



       do 


         null;
      end;

      accept Finish_Peering
                              ;


     end if;


         System_Count.Update;

      end loop;
   end;

begin 
   for I in  Id loop 
      Process(I).Get_Id(          I)          ;
   end loop;
end;

